//%attributes = {"publishedWeb":true}
// Method : u_GetBlob
// Reads a text file from disk and store it in a 4D cache table
// then use the cache table if possible

C_LONGINT:C283($L)
C_BLOB:C604($0)
If ($1=(<>webFolder+"@"))
	$file:=Substring:C12($1; Length:C16(<>webFolder)+1)
Else 
	$file:=$1
End if 

QUERY:C277([Cache:4]; [Cache:4]Request:1="File://"+$file)
$cached:=False:C215
If (Records in selection:C76([Cache:4])>0)
	GET DOCUMENT PROPERTIES:C477($1; $verrouille; $invisible; $Cdate; $Ctime; $Mdate; $Mtime)
	$L:=ITK_Date2Secs($Mdate; $Mtime; 1)
	$modified:=ITK_Secs2RFC($L; 1)
	If ($L=[Cache:4]When:3)
		$cached:=True:C214
	Else 
		READ WRITE:C146([Cache:4])
		LOAD RECORD:C52([Cache:4])
		DELETE RECORD:C58([Cache:4])
		READ ONLY:C145([Cache:4])
	End if 
End if 

If (Not:C34($Cached))
	While (Semaphore:C143($1))
		DELAY PROCESS:C323(Current process:C322; 10)
	End while 
	
	GET DOCUMENT PROPERTIES:C477($1; $verrouille; $invisible; $Cdate; $Ctime; $Mdate; $Mtime)
	$modified:=ITK_Secs2RFC(ITK_Date2Secs($Mdate; $Mtime; 1); 1)
	CLEAR SEMAPHORE:C144($1)
	
	CREATE RECORD:C68([Cache:4])
	[Cache:4]Request:1:="File://"+$file
	DOCUMENT TO BLOB:C525($1; [Cache:4]Content:2)  // Charger le document
	[Cache:4]When:3:=$L
	SAVE RECORD:C53([Cache:4])
End if 
$0:=[Cache:4]Content:2
UNLOAD RECORD:C212([Cache:4])