//%attributes = {"publishedWeb":true}
//Method : http_4DPict (stream, request)
//This method send bakc a picture conatianed in a field 
// The URL of the picture should have the form :
//     http://www.here.com/4DPict?file=2&rec=56&field=10{&format=GIF}
//
//Assumnes images are compressed with JPEG if they are QuickDraw type
//ITK_PictSize's type value shoud be more precise in a future version
//
//In the ACME demo, [Employees]photo is set to auto compress in JPEG


$file:=Num:C11(http_getparam($2; "file"; ""))
$rec:=Num:C11(http_getparam($2; "rec"; ""))
$field:=Num:C11(http_getparam($2; "field"; ""))
$format:=http_getparam($2; "format"; "")  //optionnal
lang:=http_getparam($2; "l"; "")

Case of 
	: (lang="fr")
		$suffix:="_fr"
	: (lang="de")
		$suffix:="_de"
	Else 
		lang:="us"
		$suffix:=""
End case 

$err:=0

If (Get last table number:C254<$file)
	$err:=10
End if 
If ($err=0)
	$pfile:=Table:C252($file)
	If (Get last field number:C255($file)<$field)
		$err:=11
	End if 
End if 
If ($err=0)
	<>err:=0
	ON ERR CALL:C155("ErrGotoRec")
	GOTO RECORD:C242($pfile->; $rec)
	ON ERR CALL:C155("")
	$err:=<>err
End if 
If ($err=0)
	$pfield:=Field:C253($file; $field)
	GET FIELD PROPERTIES:C258($file; $field; $type)
	If ($type#3)  //is the field a picture ?
		$err:=2
	End if 
End if 

If ($err=0)
	$size:=ITK_PictSize($pfield->; $dummy; $dummy; $dummy; $dummy; $type)
	
	If ($type=0)  //QuickDraw: assume it's JPEG
		
		If ($format="GIF")
			//We convert the image to gif      
			$gif:=ITK_Pict2GIF($pfield->; 1)
			$size:=ITK_PictSize($gif)
			$err:=http_SendHeader($1; "200 OK"; "image/gif"; $size)
			$err:=ITK_TCPSend($1; <>crlf)
			$err:=ITK_TCPSendPict($1; $gif)
			http_SendLog("/4DPict/ (JPEG->GIF)")
		Else 
			$err:=http_SendHeader($1; "200 OK"; "image/jpeg"; $size)
			$err:=ITK_TCPSend($1; <>crlf)
			$err:=ITK_TCPSendPict($1; $pfield->)
			http_SendLog("/4DPict/ (JPEG)")
		End if 
	Else   //it's GIF
		$err:=http_SendHeader($1; "200 OK"; "image/gif"; $size)
		$err:=ITK_TCPSend($1; <>crlf)
		$err:=ITK_TCPSendPict($1; $pfield->)
		http_SendLog("/4DPict/ (GIF)")
	End if 
End if 

If ($err#0)
	$err:=http_SendHeader($1; "404 Err"; "text/plain")
	$err:=ITK_TCPSend($1; <>crlf+"Error 404: Requested picture does not exist.")
End if 