//%attributes = {}
C_REAL:C285(<>lTransfered)
C_BOOLEAN:C305($Bserver)

$Bserver:=Application type:C494=4D Server:K5:6

// preload several global parameters used by the HTTP server
<>PortNum:=Num:C11(u_GetParam("http_PortNum"; "8888"))
<>http_MaxCach:=Num:C11(u_GetParam("http_MaxCachedFileSize"; "320000"))
<>http_ServerBanner:=u_GetParam("http_ServerBanner"; "ITK_Web/2.0 (ITK_ACME Demo)")
<>webFolder:=Get 4D folder:C485(Dossier base:K5:14)+"WebFolder"
<>MaxKeepAliv:=Num:C11(u_GetParam("HTTP_MaxKeepAlive"; "10"))  // maximum number of hits in a keep-alive connection

CONFIRM:C162("Activate SSL?"; "Yes"; "No")
<>useSSL:=OK=1  //Use SSL ?
<>usePW:=False:C215  //Password for SSL


//********************** TEST Certificate details added here **************************
<>SSLPassword:=""
<>SSLcertificateINT:=""
<>SSLcertificate:=LIB_Pathname(0; "Certificates"; "certreq.pem")
<>SSLkey:=LIB_Pathname(0; "Certificates"; "keyout.pem")


// some "constants"
_O_C_STRING:C293(1; <>Quot)
<>Quot:=Char:C90(34)
_O_C_STRING:C293(2; <>crlf)
<>crlf:=Char:C90(13)+Char:C90(10)

<>http_stop:=False:C215
<>lHitNum:=0
<>lTransfered:=0

// create processes to handle HTTP requests
//$register:=ITK_Register("license key")  // initialize ITK with its license number (0 if OK)


If (Not:C34($Bserver))
	CONFIRM:C162("Launch the 'ITK ACME Demo' Web server ?"; "Yes"; "No")
Else 
	OK:=1
End if 

If (OK=1)
	result:=ITK_TCPInfos($localIP; $tcpVers)
	
	<>forwin:=($tcpVers=5)  //Windows
	If (Not:C34($Bserver))
		<>Log:=New process:C317("log_Display"; 32000; "ITK Log")
	Else 
		<>Log:=0
	End if 
	<>HTTP_Master:=New process:C317("http_master"; 64000; "http_master")
	<>HTTP_Closer:=New process:C317("http_closer"; 64000; "http_closer")
End if 