//%attributes = {"publishedWeb":true}
// u_extractheader
// Routine d'extraction d'info depuis les entête au format RFC-822
// $1 -> entête (+ données éventuelles)
// $2 -> nom de l'info à extraire
// $3 -> valeur par défaut (si info pas trouvée)
// $0 <- info extraite

$p:=Position:C15(<>CRLF+<>CRLF; $1)
// suppression des données éventuelles
If ($p>0)
	$0:=<>CRLF+Substring:C12($1; 1; $p)+<>CRLF
Else 
	$0:=<>CRLF+$1+<>CRLF
End if 

$p:=Position:C15(<>CRLF+$2; $0)+2  //+2 car on retire la longueur du CR/LF
If ($p>2)
	$0:=Substring:C12($0; $p)  // on ne garde que la ligne qui nous interesse
	$0:=Substring:C12($0; 1; Position:C15(<>CRLF; $0)-1)
	
	$0:=Substring:C12($0; Position:C15(":"; $0)+1)  // on retire le nom de l'info
	
	$p:=0  // et les espaces du début
	While ($0[[$p+1]]=" ")
		$p:=$p+1
	End while 
	If ($p>0)
		$0:=Substring:C12($0; $p+1)
	End if 
Else 
	If (Count parameters:C259>2)  // CQ-25/5/99
		$0:=$3
	Else 
		$0:=""
	End if 
End if 