//%attributes = {"publishedWeb":true}
If (False:C215)
	// This database is designed to serve as an example of HTTP implementation using
	// Internet ToolKit for 4D (ITK).
	
	// This demonstration database is provided "AS IS".
	// You're free to reuse code as long as this code is used by Internet ToolKit.
	// (C) 1995-2015 by e-Node (itk@e-node.net)
	// ITK's Homepage: http://www.e-node.net/ITK
	
	// Here are the main methods used in this database by the HTTP engine:
	
	// Main optimized HTTP engine:
	http_Master  // this method is used by the "master" process to receive incoming connections
	http_Slave  // this method receive streamRef sent by htpp_Master and passes them to...
	http_Server  // this method handles the HTTP request itself (with "Keep-Alive" support)
	http_Closer  // this method is used by the "Closer" process to close streams gracefully
	// http_Server also calls the following methods
	http_SendHeader  // sends the beginning of the answer HTTP header
	http_SendDoc  // sends a static document (HTML file, GIF pictures, etc)
	http_SendRange  // handles byte range serving
	
	// Dynamic HTML generation:
	// This database uses imbeded special tags in HTML like file to include database
	// database informations dynamically using the following methods:
	http_page4D  // main dynamic HTML generation routine, which calls...
	html_Tag2Value  // converts imbeded tags into real data (heavy use of generic code)
	html_DoBlock  // handles block scoping
	http_4DPict  // used to return Pictures coming from the datafile
	
	// Database specific routines:
	http_addemp  // adds a new employee in the datafile
	http_postemp  // stores an employee in the datafile
	http_postdept  // stores an new department in the datafile
	http_search_emp  // allows searches in the employee table
	
	// More usefull generic routines:
	http_getparam  // extracts a parameter from the HTTP request
	u_ExtractHeader  // extracts one of the field found in an RFC822 formatted header
	
	// Do not hesitate to trace the code to understand how this demo works
End if 