//%attributes = {"publishedWeb":true}
// Method : http_SendHeader
// Sends the beginning of a default HTTP answer header

// $1 -> streamRef
// $2 -> HTTP error (ex: "200 OK")
// $3 -> Content-Type (ex: "text/html")
// $4 -> Content-Length (none if 0)

If (Count parameters:C259=4)
	http_hit_len:=$4
Else 
	http_hit_len:=0
End if 

$0:=ITK_TCPSend($1; "HTTP/1.1 "+$2+<>crlf; kITKBuffer)
$0:=ITK_TCPSend($1; "Date: "+ITK_Secs2RFC(u_CurrentSecs; 1)+<>crlf; kITKBuffer)
$0:=ITK_TCPSend($1; "MIME-Version: 1.0"+<>crlf; kITKBuffer)
$0:=ITK_TCPSend($1; "Content-Type: "+$3+<>crlf; kITKBuffer)
$0:=ITK_TCPSend($1; "Server: "+<>http_ServerBanner+<>crlf; kITKBuffer)
$0:=ITK_TCPSend($1; "Accept-ranges: bytes"+<>crlf; kITKBuffer)
If (http_hit_len#0)
	$0:=ITK_TCPSend($1; "Content-Length: "+String:C10(http_hit_len)+<>crlf; kITKBuffer)
	If (keep_alive=True:C214)
		$0:=ITK_TCPSend($1; "Connection: Keep-Alive"+<>crlf; kITKBuffer)
	End if 
Else 
	keep_alive:=False:C215
End if 

http_hit_err:=Num:C11(Substring:C12($2; 1; 3))  // keep the HTTP Error returned

// do not forget to send the remaining of the header