//%attributes = {"publishedWeb":true}
// Method : http_SendRange
// Byte range serving implementation
// sends byte ranges from a file

// $1 -> streamRef
// $2 -> HTTP request
// $3 -> MIME Type
// $4 -> last modification  
// $5 -> file pathname
// $6 -> file length

C_LONGINT:C283($1; $6; $0)
C_TEXT:C284($2; $3; $4; $5)
$c:=$1

$boundary:="____multipart/boundary____"
http_SendHeader($c; "206 OK"; "multipart/x-byteranges; boundary="+$boundary)
If ($4#"")
	$err:=ITK_TCPSend($c; "Last-Modified: "+$4+<>crlf; 1)
End if 
$err:=ITK_TCPSend($c; <>crlf; 1)

$ranges:=u_ExtractHeader($2; "Range"; "")
If ($ranges="")
	$ranges:=u_ExtractHeader($2; "Request-range"; "")
End if 
$ranges:=Substring:C12($ranges; Position:C15("="; $ranges)+1)+","
$0:=0

While (($ranges#"") & (ITK_TCPStatus($c)=kStreamStatusEstablished))
	$p1:=Position:C15("-"; $ranges)
	$p2:=Position:C15(","; $ranges)
	$start:=Substring:C12($ranges; 1; $p1-1)
	$end:=Substring:C12($ranges; $p1+1; $p2-1)
	$end:=Substring:C12($end; 1; Position:C15(","; $end)-1)
	If ($end="")
		$end:=$start
		$start:="0"
	End if 
	If ($start="")
		$start:=String:C10($6-Num:C11($end))
		$end:=String:C10($6)
	End if 
	$ranges:=Substring:C12($ranges; $p2+1)
	// send one range
	$send:="--"+$boundary+<>crlf+"Content-type: "+$3+<>crlf
	$send:=$send+"Content-range: bytes "+$start+"-"+$end+"/"+String:C10($6)+<>crlf+<>crlf
	$err:=ITK_TCPSend($c; $send)
	$err:=ITK_TCPSendFile($c; $5; 0; 0; Num:C11($start); Num:C11($end))
	$err:=ITK_TCPSend($c; <>crlf)
	$0:=$0+Length:C16($send)+Num:C11($end)-Num:C11($start)+4
End while 

$err:=ITK_TCPSend($c; "--"+$boundary+"--"+<>crlf)