//%attributes = {"publishedWeb":true}

$fname:=http_getparam($2; "fname"; "")
$lname:=http_getparam($2; "lname"; "")
$title:=http_getparam($2; "title"; "")
$phone:=http_getparam($2; "phone"; "")
$email:=http_getparam($2; "email"; "")
$dept:=http_getparam($2; "dept"; "")
$dayB:=Num:C11(http_getparam($2; "dayB"; ""))
$MonthB:=Num:C11(http_getparam($2; "MonthB"; ""))
$YearB:=Num:C11(http_getparam($2; "YearB"; ""))
$dayH:=Num:C11(http_getparam($2; "dayH"; ""))
$monthH:=Num:C11(http_getparam($2; "MonthH"; ""))
$yearH:=Num:C11(http_getparam($2; "YearH"; ""))
lang:=(http_getparam($2; "l"; ""))

$errorFold:=<>WebFolder+Séparateur dossier:K24:12+"ErrorText"+Séparateur dossier:K24:12

Case of 
	: (lang="fr")
		$suffix:="_fr"
	: (lang="de")
		$suffix:="_de"
	Else 
		lang:="us"
		$suffix:=""
End case 

$errtext:=""
If ($fname="")
	$errtext:=$errtext+U_GetTextBlock($errorFold+"errFirstName"+$suffix+".txt")+"<br>"
End if 

If ($lname="")
	$errtext:=$errtext+U_GetTextBlock($errorFold+"errLastName"+$suffix+".txt")+"<br>"
End if 

If ($dept="")
	$errtext:=$errtext+U_GetTextBlock($errorFold+"errDeptName"+$suffix+".txt")+"<br>"
End if 

If (($yearH<100) & ($yearH>-1))
	$yearH:=(Year of:C25(Current date:C33)\100)*100+$yearH
End if 

If (($yearB<100) & ($yearB>-1))
	$yearB:=(Year of:C25(Current date:C33)\100)*100+$yearB
End if 

If (u_BadDate($dayB; $monthB; $yearB))
	$errtext:=$errtext+U_GetTextBlock($errorFold+"errBirthDate"+$suffix+".txt")+"<br>"
End if 

If (u_BadDate($dayH; $monthH; $yearH))
	$errtext:=$errtext+U_GetTextBlock($errorFold+"errHireDate"+$suffix+".txt")+"<br>"
End if 

If ($errtext="")
	QUERY:C277([Departments:3]; [Departments:3]Name:1=$dept)
	If (Records in selection:C76([Departments:3])=0)
		$errtext:=$errtext+U_GetTextBlock($errorFold+"errDeptInv"+$suffix+".txt")+"<br>"
		
	Else 
		$dept:=String:C10([Departments:3]DeptNum:2)
	End if 
End if 

If ($errtext#"")
	http_errMess($1; <>WebFolder+Séparateur dossier:K24:12+"BadEmployee"+$suffix+".html"; $errtext)
	http_SendLog("/Add employee -> REJECTED")
Else 
	http_SendLog("/Add employee -> ADDED")
	
	$num:=u_GetAddParam("Emp_Num")
	CREATE RECORD:C68([Employees:2])
	[Employees:2]FirstName:1:=$fname
	[Employees:2]LastName:2:=$lname
	[Employees:2]Title:3:=$title
	[Employees:2]Phone:4:=$phone
	[Employees:2]email:5:=$email
	[Employees:2]DeptNum:6:=Num:C11($dept)
	[Employees:2]EmployeeNum:7:=$num
	[Employees:2]BirthDate:8:=Date:C102(String:C10($dayB)+"/"+String:C10($monthB)+"/"+String:C10($yearB))
	[Employees:2]DateHired:9:=Date:C102(String:C10($dayH)+"/"+String:C10($monthH)+"/"+String:C10($yearH))
	SAVE RECORD:C53([Employees:2])
	$err:=http_SendHeader($1; "200 OK"; "text/html; charset=utf-8")
	$err:=ITK_TCPSend($1; <>crlf)
	$err:=http_page4D($1; <>WebFolder+Séparateur dossier:K24:12+"Employee"+$suffix+".html"; 0)
End if 